package superwaba.ext.xplat.html;

import waba.sys.*;

/**
 * Class that builds a string by appending characters
 * but allocating the space in blocks like a vector.
 * The string class was too expensive as was StringBuffer.
 */
public class CharBuf
{
  public char[] buf;
  public int len;
  private int capacity;

  public CharBuf()
  {
    capacity = 10;
    len = 0;
    buf = new char[10];
  }

  public void clear()
  {
    len = 0;
  }

  public void append(char c)
  {
    //System.out.println("appending '" + c + "'" + " " + len + " " + capacity);

    if (len+1 >= capacity)
    {
      // need to increase capacity.
      char[] newbuff = new char[capacity*12/10];
      Vm.copyArray(buf, 0, newbuff, 0, capacity);
      capacity = capacity * 12 / 10;
      buf = newbuff;
    }
    buf[len++] = c;
  }

  /**
   * Trim spaces from front and back.
   */
  public void trim() // guich@330_31: changed completely the algorithm.
  {
      int len = buf.length;
      int st = 0;
      while (st < len && buf[st] <= ' ')
         st++;

      while (st < len && buf[len - 1] <= ' ')
         len--;

      if (st > 0 || len < buf.length)
         Vm.copyArray(buf, st, buf, 0, len-st);
  }

  public String toString()
  {
    return new String(buf, 0, len);
  }
}
