package superwaba.ext.xplat.html;

import waba.util.*;

/**
 * The <code>Document</code> class is the root of the HTML tree containing a list
 * of child HTML objects and a title and base URL.
 *
 * @version $Header: $
 * @author Jim Guistwite
 */

public class Document implements ElementCollection
{
  /**
   * Base URL for this document.
   */
  public String base;

  /**
   * Title associated with this document.
   */
  public String title;

  /**
   * Children of this document.
   */
  public Vector children;

  /**
   * Construct a new document with no children and a blank title.
   */
  public Document()
  {
    children = new Vector();
    title = "";
  }

  /**
   * Implement the ElementCollection interface method to add an element
   * to this document.
   * @param e element to be added to this one.
   */
  public void add(Element e)
  {
    children.add(e);
  }
}
