package superwaba.ext.xplat.html;

import waba.ui.*;

/**
 * The <code>HtmlButton</code> is a special subclass of superwaba.ext.xplat.wgl.ui.JButton
 * to be used in an HTML form.
 *
 * @version $Header: $
 * @author Jim Guistwite
 */

public class HtmlButton extends Button implements HtmlControl
{
  HtmlRenderer r;


  /**
   * Construct an HtmlButton with the text provided.
   * @param s string to be displayed in button.
   */
  public HtmlButton(String s) {
    super(s);
  }

  /**
   * Set the renderer associated with this HTML control
   * @param r renderer for this control
   */
  public void setRenderer(HtmlRenderer r)
  {
    this.r = r;
  }

  /**
   * Override the repaint method because since it's inside the form
   * it doesn't work properly.
   */
  public void repaint()
  {
    if (r != null)
      r.requestRepaint(this);
  }
}
