package superwaba.ext.xplat.html;

import waba.util.*;
/**
 * The <code>HtmlListener</code> interface is called by the HtmlTokenizer
 * while tokenizing the contents of a HTML string.  The idea is to keep
 * this similar to the SAX XML interface for parsing XML.
 *
 * @version $Header: $
 * @author Jim Guistwite
 */

public interface HtmlListener
{
  /**
   * This method is called when a new tag is encountered while
   * parsing the HTML.
   * @param tag integer version of the tag encountered.
   * @param prop Hashtable associated with the tag.
   */
  public void startElement(int tag, Hashtable prop);

  /**
   * This method is called when the end tag is encountered for a
   * given tag.
   * @param tag tag which is ended.
   */
  public void endElement(int tag);

  /**
   * This method is called when some text is encountered.
   * @param data text to be processed.
   */
  public void characters(String data);

  /**
   * This method is called when a comment is read by the tokenizer.
   * @param data comment to be processed.
   */
  public void comment(String data);
}
