package superwaba.ext.xplat.html;

/**
 * The <code>LayoutContext</code> class is used during the
 * layout process of the HTML components like a graphics
 * contents is used during drawing operations.
 *
 * @version $Header: $
 * @author Jim Guistwite
 */

public class LayoutContext
{
  /**
   * Current x location during layout operations.
   */
  public int x;

  /**
   * Current y location during layout operations.
   */
  public int y;

  /**
   * height of current line.
   */
  public int lineHeight;

  /**
   * Width of the container.  This is set by the HtmlRenderer.
   */
  public int rendererWidth;

  /**
   * Height of the container.  This is set by the HtmlRenderer.
   */
  public int rendererHeight;

  /**
   * Preferred width of content when layout complete.
   */
  public int preferredWidth;

  /**
   * Preferred height of content when layout complete.
   */
  public int preferredHeight;

  /**
   * true if text has been added to the current line.
   */
  public boolean textOnLine;

  /**
   * Construct a layout context.
   */
  public LayoutContext()
  {
  }
}
