package superwaba.ext.xplat.html;

/**
 * The <code>RendererListener</code> interface is registered with the
 * HtmlRenderer to handle events that need to be propagated back from
 * the renderer into a browser.  These include setting a message for
 * the user and following links to new pages.
 *
 * @version $Header: $
 * @author Jim Guistwite
 */

public interface RendererListener
{
  /**
   * Set the message that should be displayed to the user.
   * @param msg message to be displayed.
   */
  public void setMessage(String msg);

  /**
   * Cause the browser to follow a link.
   * @param url url for new web page to view.
   */
  public void linkSelection(String url);
}
