/*********************************************************************************
 *  Copyright (C) 2002 Guilherme Campos Hazan <guich@superwaba.org.>             *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library is NOT free software.                                           *
 *  Once you paid for it, you can use it in how many devices you want.           *
 *                                                                               *
 *********************************************************************************/

package superwaba.ext.xplat.io.print;

import superwaba.ext.xplat.io.print.PrinterException;

/** This class is used to get the text height and width for a given font.
  */

public abstract class FontMetrics
{
	private Font font;

	public FontMetrics(Font font)
	{
		this.font = font;
	}

   /** Returns the height of the current font */
	public abstract int getHeight() throws PrinterException, NotSupportedException;

	/** Returns the text width in the current font */
	public abstract int getTextWidth(String s) throws PrinterException, NotSupportedException;
}