/*********************************************************************************
 *  Copyright (C) 2002 Guilherme Campos Hazan <guich@superwaba.org.>             *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library is NOT free software.                                           *
 *  Once you paid for it, you can use it in how many devices you want.           *
 *                                                                               *
 *********************************************************************************/

package superwaba.ext.xplat.io.print;

/** This class is used to get and set various settings from the printer.
  * Each driver has its own set of settings.
  */

public abstract class Settings
{
   /** This class can't be instantiated. */
	protected Settings()
	{
   }

   /** Sets a value as String */
	public abstract void set(int what, String s) throws NotSupportedException, PrinterException;
	/** Sets a value as integer */
	public abstract void set(int what, int i) throws NotSupportedException, PrinterException;
	/** Sets a value as float */
	public abstract void set(int what, float i) throws NotSupportedException, PrinterException;

   /** Gets a String value */
	public abstract String getString(int what) throws NotSupportedException, PrinterException;
	/** Gets an integer value */
	public abstract int getInt(int what) throws NotSupportedException, PrinterException;
	/** Gets a float value */
	public abstract float getFloat(int what) throws NotSupportedException, PrinterException;
}