/*********************************************************************************
 *  Copyright (C) 2002 Guilherme Campos Hazan <guich@superwaba.org.>             *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library is NOT free software.                                           *
 *  Once you paid for it, you can use it in how many devices you want.           *
 *                                                                               *
 *********************************************************************************/

package superwaba.ext.xplat.io.print;

/** This class acts like a simple typewriter. You can print only text through
  * it. And, if supported, also set the font. Very good if sending just text is
  * enough for you.
  */
public abstract class TypeWriter
{
   /** This class cannot be instantiated */
	protected TypeWriter() throws NotSupportedException
	{
	}

	/** This method prints the given String using the current font. The text
	  * is not wrapped at end of line.
	  */
	public abstract void println(String s) throws PrinterException;
	/** This method prints the given String using the current font. The text
	  * is wrapped at end of line.
	  */
	public abstract void printParagraph(String s) throws PrinterException, NotSupportedException;
	/** Sets the font. This method may not be supported.
	  */
	public abstract void setFont(superwaba.ext.xplat.io.print.Font font) throws PrinterException, NotSupportedException;
}