
/*********************************************************************************
  *  SuperWaba Virtual Machine, version 4                                         *
  *  Copyright (C) 2003 Guilherme Campos Hazan <support@superwaba.com.br>         *
  *                 and Andy DePue <sir_anodos@yahoo.com>                         *
  *  All Rights Reserved                                                          *
  *                                                                               *
  *  This library and virtual machine is free software; you can redistribute      *
  *  it and/or modify it under the terms of the Amended GNU Lesser General        *
  *  Public License distributed with this software.                               *
  *                                                                               *
  *  This library and virtual machine is distributed in the hope that it will     *
  *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
  *                                                                               *
  *  All software that links or interacts with this library and virtual machine,  *
  *  or any derivative works, require the software to prominently display the     *
  *  following notice:                                                            *
  *                                                                               *
  *                   Created with SuperWaba                                      *
  *                  http://www.superwaba.org                                     *
  *                                                                               *
  *  Please see the software license located at SuperWabaSDK/license.txt          *
  *  for more details.                                                            *
  *                                                                               *
  *  You should have received a copy of the License along with this software;     *
  *  if not, write to                                                             *
  *                                                                               *
  *     Guilherme Campos Hazan                                                    *
  *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
  *     Rio de Janeiro / RJ - Brazil                                              *
  *     Cep: 22050-000                                                            *
  *     E-mail: support@superwaba.com.br                                          *
  *                                                                               *
  *********************************************************************************/
package superwaba.ext.xplat.sql.db2e.db2ex;
import waba.sys.*;

public class Db2e
{
   public static final int SQL_HANDLE_ENV = 1;
   public static final int SQL_HANDLE_DBC = 2;
   public static final int SQL_HANDLE_STMT = 3;
   public static final int SQL_PARAM_INPUT = 1;
   public static final int SQL_PARAM_INPUT_OUTPUT = 2;
   public static final int SQL_PARAM_OUTPUT = 3;
   public static final int SQL_C_BINARY = 1;
   public static final int SQL_C_BIT = 2;
   public static final int SQL_C_CHAR = 3;
   public static final int SQL_C_DOUBLE = 4;
   public static final int SQL_C_FLOAT = 5;
   public static final int SQL_C_LONG = 6;
   public static final int SQL_C_SHORT = 7;
   public static final int SQL_C_TYPE_DATE = 8;
   public static final int SQL_C_TYPE_TIME = 9;
   public static final int SQL_C_TYPE_TIMESTAMP = 10;
   public static final int SQL_C_TINYINT = 11;
   public static final int SQL_BLOB = 1;
   public static final int SQL_CHAR = 2;
   public static final int SQL_DECIMAL = 3;
   public static final int SQL_INTEGER = 4;
   public static final int SQL_SMALLINT = 5;
   public static final int SQL_TYPE_DATE = 6;
   public static final int SQL_TYPE_TIME = 7;
   public static final int SQL_TYPE_TIMESTAMP = 8;
   public static final int SQL_VARCHAR = 9;
   public static final int SQL_FETCH_NEXT = 1;
   public static final int SQL_FETCH_PRIOR = 2;
   public static final int SQL_FETCH_FIRST = 3;
   public static final int SQL_FETCH_LAST = 4;
   public static final int SQL_FETCH_ABSOLUTE = 5;
   public static final int SQL_FETCH_RELATIVE = 6;
   public static final int SQL_COMMIT = 1;
   public static final int SQL_ROLLBACK = 2;
   public static final int SQL_CURSOR_FORWARD_ONLY = 1;
   public static final int SQL_CURSOR_STATIC = 2;
   public static final int SQL_DELETE_MARK_ONLY = 1;
   public static final int SQL_DELETE_PHYSICAL_REMOVE = 2;
   public static final int SQL_READ_EXCLUDE_MARKED_DELETE = 1;
   public static final int SQL_READ_INCLUDE_MARKED_DELETE = 2;
   public static final int SQL_DIRTYBIT_SET_BY_SYSTEM = 1;
   public static final int SQL_DIRTYBIT_SET_BY_APPLICATION = 2;
   public static final int SQL_REORG_ENABLED = 1;
   public static final int SQL_REORG_DISABLED = 2;
   public static final int SQL_NULL_DATA = -1;
   private static boolean _isNativeAttached = false;
   public Db2e()
   {

   }
   public static boolean isNativeAttached()
   {
      return _isNativeAttached;
   }
   public static boolean attachNative()
   {
      if(!_isNativeAttached)
         return (_isNativeAttached = Vm.attachNativeLibrary("XPlatSqlDB2e")); // andy@350_9: fixed problem generated by guich that renamed the library without updating this source file
      else
         return true;
   }
   public int allocHandle(int handleType, int contextHandle) throws DB2Exception
   {
      return NativeMethods4JDK.db2eAllocHandle(handleType, contextHandle);
   }
   public void freeHandle(int handleType, int handle) throws DB2Exception
   {
      NativeMethods4JDK.db2eFreeHandle(handleType, handle);
   }
   public void resetStatementParams(int statementHandle) throws DB2Exception
   {
      NativeMethods4JDK.db2eResetStatementParams(statementHandle);
   }
   public void connect(int connectionHandle, String serverName, String userName, String authentication) throws DB2Exception
   {
      NativeMethods4JDK.db2eConnect(connectionHandle, serverName, userName, authentication);
   }
   public void disconnect(int connectionHandle) throws DB2Exception
   {
      NativeMethods4JDK.db2eDisconnect(connectionHandle);
   }
   public void prepare(int statementHandle, String statement) throws DB2Exception
   {
      NativeMethods4JDK.db2ePrepare(statementHandle, statement);
   }
   public void execute(int statementHandle) throws DB2Exception
   {
      NativeMethods4JDK.db2eExecute(statementHandle);
   }
   public void execDirect(int statementHandle, String statement) throws DB2Exception
   {
      NativeMethods4JDK.db2eExecDirect(statementHandle, statement);
   }
   public void endTran(int handleType, int handle, int completionType) throws DB2Exception
   {
      NativeMethods4JDK.db2eEndTran(handleType, handle, completionType);
   }
   public int getRowCount(int statementHandle) throws DB2Exception
   {
      return NativeMethods4JDK.db2eGetRowCount(statementHandle);
   }
   public void setAutoCommit(int dbcHandle, boolean autocommit) throws DB2Exception
   {
      NativeMethods4JDK.db2eSetAutoCommit(dbcHandle, autocommit);
   }
   public void setCursorType(int statementHandle, int type) throws DB2Exception
   {
      NativeMethods4JDK.db2eSetCursorType(statementHandle, type);
   }
   public void setDeleteMode(int statementHandle, int mode) throws DB2Exception
   {
      NativeMethods4JDK.db2eSetDeleteMode(statementHandle, mode);
   }
   public void setReadMode(int statementHandle, int mode) throws DB2Exception
   {
      NativeMethods4JDK.db2eSetReadMode(statementHandle, mode);
   }
   public void setDirtybitMode(int statementHandle, int mode) throws DB2Exception
   {
      NativeMethods4JDK.db2eSetDirtybitMode(statementHandle, mode);
   }
   public void setReorgMode(int statementHandle, int mode) throws DB2Exception
   {
      NativeMethods4JDK.db2eSetReorgMode(statementHandle, mode);
   }

   // Column data fetching...
   public void bindBlob(int statementHandle, int column, Db2eBoundBlob blob) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindBlob(statementHandle, column, blob);
   }
   public void bindString(int statementHandle, int column, Db2eBoundString str) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindString(statementHandle, column, str);
   }
   public void bindInteger(int statementHandle, int column, Db2eBoundInt value) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindInteger(statementHandle, column, value);
   }
   public void bindTime(int statementHandle, int column, Db2eBoundTime time) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindTime(statementHandle, column, time);
   }
   public void bindDate(int statementHandle, int column, Db2eBoundDate date) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindDate(statementHandle, column, date);
   }
   public void bindTimestamp(int statementHandle, int column, Db2eBoundTimestamp date) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindTimestamp(statementHandle, column, date);
   }
   public int getBlob(int statementHandle, int column, byte[] buffer) throws DB2Exception
   {
      return NativeMethods4JDK.db2eGetBlob(statementHandle, column, buffer);
   }
   public int getString(int statementHandle, int column, byte[] cstr) throws DB2Exception
   {
      return NativeMethods4JDK.db2eGetString(statementHandle, column, cstr);
   }

   // AlD - 7/1/03: Added support for detecting null integer values.  Changed
   //               from using a straight 'int' to using the Db2eBoundInt.
   public Db2eBoundInt getInteger(int statementHandle, int column, Db2eBoundInt integer) throws DB2Exception
   {
      return NativeMethods4JDK.db2eGetInteger(statementHandle, column, integer);
   }
   public Db2eBoundTime getTime(int statementHandle, int column, Db2eBoundTime store) throws DB2Exception
   {
      return NativeMethods4JDK.db2eGetTime(statementHandle, column, store);
   }
   public Db2eBoundDate getDate(int statementHandle, int column, Db2eBoundDate store) throws DB2Exception
   {
      return NativeMethods4JDK.db2eGetDate(statementHandle, column, store);
   }
   public Db2eBoundTimestamp getTimestamp(int statementHandle, int column, Db2eBoundTimestamp store) throws DB2Exception
   {
      return NativeMethods4JDK.db2eGetTimestamp(statementHandle, column, store);
   }
   public boolean fetch(int statementHandle) throws DB2Exception
   {
      return NativeMethods4JDK.db2eFetch(statementHandle);
   }
   public boolean fetchScroll(int statementHandle, int fetchOrientation, int fetchOffset) throws DB2Exception
   {
      return NativeMethods4JDK.db2eFetchScroll(statementHandle, fetchOrientation, fetchOffset);
   }
   public int getNumResultCols(int statementHandle) throws DB2Exception
   {
      return NativeMethods4JDK.db2eGetNumResultCols(statementHandle);
   }
   public void describeCol(int statementHandle, int columnNum, Db2eColumnInfo infoBuf) throws DB2Exception
   {
      NativeMethods4JDK.db2eDescribeCol(statementHandle, columnNum, infoBuf);
   }

   /**
     * Parameter binding methods.
     */
   public void bindBlobParam(int statementHandle, int paramNum, Db2eBoundBlob blob) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindBlobParam(statementHandle, paramNum, blob);
   }
   public void bindCharParam(int statementHandle, int paramNum, Db2eBoundString str) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindCharParam(statementHandle, paramNum, str);
   }
   public void bindDecimalParam(int statementHandle, int paramNum, Db2eBoundInt value, int decimalDigits) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindDecimalParam(statementHandle, paramNum, value, decimalDigits);
   }
   public void bindIntegerParam(int statementHandle, int paramNum, Db2eBoundInt integer) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindIntegerParam(statementHandle, paramNum, integer);
   }
   public void bindSmallIntParam(int statementHandle, int paramNum, Db2eBoundInt integer) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindSmallIntParam(statementHandle, paramNum, integer);
   }
   public void bindVarcharParam(int statementHandle, int paramNum, Db2eBoundString str) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindVcParam(statementHandle, paramNum, str);
   }
   public void bindTimeParam(int statementHandle, int paramNum, Db2eBoundTime time) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindTimeParam(statementHandle, paramNum, time);
   }
   public void bindDateParam(int statementHandle, int paramNum, Db2eBoundDate date) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindDateParam(statementHandle, paramNum, date);
   }
   public void bindTimestampParam(int statementHandle, int paramNum, Db2eBoundTimestamp timestamp) throws DB2Exception
   {
      NativeMethods4JDK.db2eBindTimestampParam(statementHandle, paramNum, timestamp);
   }
}
