
/*********************************************************************************
  *  SuperWaba Virtual Machine, version 4                                         *
  *  Copyright (C) 2003 Guilherme Campos Hazan <support@superwaba.com.br>         *
  *                 and Andy DePue <sir_anodos@yahoo.com>                         *
  *  All Rights Reserved                                                          *
  *                                                                               *
  *  This library and virtual machine is free software; you can redistribute      *
  *  it and/or modify it under the terms of the Amended GNU Lesser General        *
  *  Public License distributed with this software.                               *
  *                                                                               *
  *  This library and virtual machine is distributed in the hope that it will     *
  *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
  *                                                                               *
  *  All software that links or interacts with this library and virtual machine,  *
  *  or any derivative works, require the software to prominently display the     *
  *  following notice:                                                            *
  *                                                                               *
  *                   Created with SuperWaba                                      *
  *                  http://www.superwaba.org                                     *
  *                                                                               *
  *  Please see the software license located at SuperWabaSDK/license.txt          *
  *  for more details.                                                            *
  *                                                                               *
  *  You should have received a copy of the License along with this software;     *
  *  if not, write to                                                             *
  *                                                                               *
  *     Guilherme Campos Hazan                                                    *
  *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
  *     Rio de Janeiro / RJ - Brazil                                              *
  *     Cep: 22050-000                                                            *
  *     E-mail: support@superwaba.com.br                                          *
  *                                                                               *
  *********************************************************************************/
package superwaba.ext.xplat.sql.db2e.db2ex;

public class Db2eBoundTimestamp
{

   // WARNING!  DO NOT CHANGE THE ORDER THAT THESE FIELDS APPEAR IN THIS

   // CLASS, AS THE NATIVE CODE REFERENCES THE FIELDS BY #.

   // IF YOU NEED TO ADD FIELDS, ADD THEM AFTER THE LAST FIELD DEFINED HERE.

   // IF YOU NEED TO REMOVE FIELDS, BE SURE TO MODIFY THE NATIVE CODE.
   public int year;
   public int month;
   public int day;
   public int hour;
   public int minute;
   public int second;
   public int fraction;
   public int nullIndicator;

   // I make this a little larger to be on the safe side.
   protected byte[] _C_TIMESTAMP_STRUCT = new byte[7 * 4];
   public Db2eBoundTimestamp()
   {

      // Initialize with all 0s.
      translateToDb2e();
   }
   public Db2eBoundTimestamp(int year, int month, int day)
   {
      this.year = year;
      this.month = month;
      this.day = day;
      translateToDb2e();
   }
   public Db2eBoundTimestamp(int hour, int minute, int second, int fraction)
   {
      this.hour = hour;
      this.minute = minute;
      this.second = second;
      this.fraction = fraction;
      translateToDb2e();
   }
   public Db2eBoundTimestamp(int year, int month, int day, int hour, int minute, int second, int fraction)
   {
      this.year = year;
      this.month = month;
      this.day = day;
      this.hour = hour;
      this.minute = minute;
      this.second = second;
      this.fraction = fraction;
      translateToDb2e();
   }
   public void translateToDb2e()
   {
      NativeMethods4JDK.btsTranslateToDb2e(this);
   }
   public void translateFromDb2e()
   {
      NativeMethods4JDK.btsTranslateFromDb2e(this);
   }
}
