
/*********************************************************************************
  *  SuperWaba Virtual Machine, version 4                                         *
  *  Copyright (C) 2003 Guilherme Campos Hazan <support@superwaba.com.br>         *
  *                 and Andy DePue <sir_anodos@yahoo.com>                         *
  *  All Rights Reserved                                                          *
  *                                                                               *
  *  This library and virtual machine is free software; you can redistribute      *
  *  it and/or modify it under the terms of the Amended GNU Lesser General        *
  *  Public License distributed with this software.                               *
  *                                                                               *
  *  This library and virtual machine is distributed in the hope that it will     *
  *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
  *                                                                               *
  *  All software that links or interacts with this library and virtual machine,  *
  *  or any derivative works, require the software to prominently display the     *
  *  following notice:                                                            *
  *                                                                               *
  *                   Created with SuperWaba                                      *
  *                  http://www.superwaba.org                                     *
  *                                                                               *
  *  Please see the software license located at SuperWabaSDK/license.txt          *
  *  for more details.                                                            *
  *                                                                               *
  *  You should have received a copy of the License along with this software;     *
  *  if not, write to                                                             *
  *                                                                               *
  *     Guilherme Campos Hazan                                                    *
  *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
  *     Rio de Janeiro / RJ - Brazil                                              *
  *     Cep: 22050-000                                                            *
  *     E-mail: support@superwaba.com.br                                          *
  *                                                                               *
  *********************************************************************************/
package superwaba.ext.xplat.sql.db2e.db2ex;

/** This class is for internal use only. There are no public methods. */

class NativeMethods
{
   native static int db2eAllocHandle(int handleType, int contextHandle) throws DB2Exception;
   native static void db2eFreeHandle(int handleType, int handle) throws DB2Exception;
   native static void db2eResetStatementParams(int statementHandle) throws DB2Exception;
   native static void db2eConnect(int connectionHandle, String serverName, String userName, String authentication) throws DB2Exception;
   native static void db2eDisconnect(int connectionHandle) throws DB2Exception;
   native static void db2ePrepare(int statementHandle, String statement) throws DB2Exception;
   native static void db2eExecute(int statementHandle) throws DB2Exception;
   native static void db2eExecDirect(int statementHandle, String statement) throws DB2Exception;
   native static void db2eEndTran(int handleType, int handle, int completionType) throws DB2Exception;
   native static int db2eGetRowCount(int statementHandle) throws DB2Exception;
   native static void db2eSetAutoCommit(int dbcHandle, boolean autocommit) throws DB2Exception;
   native static void db2eSetCursorType(int statementHandle, int type) throws DB2Exception;
   native static void db2eSetDeleteMode(int statementHandle, int mode) throws DB2Exception;
   native static void db2eSetReadMode(int statementHandle, int mode) throws DB2Exception;
   native static void db2eSetDirtybitMode(int statementHandle, int mode) throws DB2Exception;
   native static void db2eSetReorgMode(int statementHandle, int mode) throws DB2Exception;

   // Column data fetching...
   native static void db2eBindBlob(int statementHandle, int column, Db2eBoundBlob blob) throws DB2Exception;
   native static void db2eBindString(int statementHandle, int column, Db2eBoundString str) throws DB2Exception;
   native static void db2eBindInteger(int statementHandle, int column, Db2eBoundInt value) throws DB2Exception;
   native static void db2eBindTime(int statementHandle, int column, Db2eBoundTime time) throws DB2Exception;
   native static void db2eBindDate(int statementHandle, int column, Db2eBoundDate date) throws DB2Exception;
   native static void db2eBindTimestamp(int statementHandle, int column, Db2eBoundTimestamp timestamp) throws DB2Exception;
   native static int db2eGetBlob(int statementHandle, int column, byte[] buffer) throws DB2Exception;
   native static int db2eGetString(int statementHandle, int column, byte[] cstr) throws DB2Exception;
   native static Db2eBoundInt db2eGetInteger(int statementHandle, int column, Db2eBoundInt integer) throws DB2Exception;
   native static Db2eBoundTime db2eGetTime(int statementHandle, int column, Db2eBoundTime time) throws DB2Exception;
   native static Db2eBoundDate db2eGetDate(int statementHandle, int column, Db2eBoundDate date) throws DB2Exception;
   native static Db2eBoundTimestamp db2eGetTimestamp(int statementHandle, int column, Db2eBoundTimestamp timestamp) throws DB2Exception;
   native static boolean db2eFetch(int statementHandle) throws DB2Exception;
   native static boolean db2eFetchScroll(int statementHandle, int fetchOrientation, int fetchOffset) throws DB2Exception;
   native static int db2eGetNumResultCols(int statementHandle) throws DB2Exception;
   native static void db2eDescribeCol(int statementHandle, int columnNum, Db2eColumnInfo infoBuf) throws DB2Exception;

   /**
     * Parameter binding methods.
     */
   native static void db2eBindBlobParam(int statementHandle, int paramNum, Db2eBoundBlob blob) throws DB2Exception;
   native static void db2eBindCharParam(int statementHandle, int paramNum, Db2eBoundString str) throws DB2Exception;
   native static void db2eBindDecimalParam(int statementHandle, int paramNum, Db2eBoundInt value, int decimalDigits) throws DB2Exception;
   native static void db2eBindIntegerParam(int statementHandle, int paramNum, Db2eBoundInt integer) throws DB2Exception;
   native static void db2eBindSmallIntParam(int statementHandle, int paramNum, Db2eBoundInt integer) throws DB2Exception;
   native static void db2eBindVcParam(int statementHandle, int paramNum, Db2eBoundString str) throws DB2Exception;
   native static void db2eBindTimeParam(int statementHandle, int column, Db2eBoundTime time) throws DB2Exception;
   native static void db2eBindDateParam(int statementHandle, int column, Db2eBoundDate date) throws DB2Exception;
   native static void db2eBindTimestampParam(int statementHandle, int column, Db2eBoundTimestamp timestamp) throws DB2Exception;

   /**
     * Db2eBoundTimestamp methods.
     */
   native static void btsTranslateToDb2e(Db2eBoundTimestamp bts);
   native static void btsTranslateFromDb2e(Db2eBoundTimestamp bts);
   native static void btTranslateToDb2e(Db2eBoundTime bt);
   native static void btTranslateFromDb2e(Db2eBoundTime bt);
   native static void bdTranslateToDb2e(Db2eBoundDate bd);
   native static void bdTranslateFromDb2e(Db2eBoundDate bd);
}
