/** Created by Jean Rissoto and Guilherme Campos Hazan */

package superwaba.ext.xplat.ui;

import waba.ui.*;
import waba.fx.*;
import waba.sys.*;

/** a popup Menu to be used with the MultiEdit class.  */

public final class MultiEditMenu extends Window
{
	private Timer t;
	private KeyEvent e;

	private PushButtonGroup pbg;
   private Control callingControl;
   private static String menuItems[] = {"X","C","P",null, "S","R"," ",null, "*"};

   public MultiEditMenu()
	{
	   super("Command",RECT_BORDER);
  	   setBackColor(Settings.isColor ? new Color(220,220,0) : Color.BRIGHT);
      pbg = new PushButtonGroup(menuItems,false,-1,-1,4,0,true,PushButtonGroup.BUTTON);
      highResPrepared = true;
      setRect(CENTER,CENTER,pbg.getPreferredWidth()+6,(pbg.getPreferredHeight()<<1)+6);
      add(pbg, CENTER,CENTER);
	}

   protected void onPopup()
   {
      callingControl = getTopMost().getFocus();
      t = addTimer(3000);
      e = null;
   }

   protected void postUnpop()
   {
      if (callingControl instanceof MultiEdit)
         ((MultiEdit)callingControl).popPosState();
//      if (callingControl instanceof Edit)
//         ((Edit)callingControl).popPosState();

      if (e != null)
         callingControl.onEvent(e);
      else
         callingControl.requestFocus();
   }
   private void close()
   {
       if (t != null)
          removeTimer(t);
       t = null;
       unpop();
   }
   public void onEvent(Event event)
   {
       switch (event.type)
       {
           case ControlEvent.TIMER:
               event.consumed=true;     //astein@230_5: prevent blinking cursor event from propagating
               close();
               break;
           case ControlEvent.PRESSED:
               if (event.target == pbg)
               {
                  e = new KeyEvent();
                  e.type   = KeyEvent.KEY_PRESS;
                  e.target = callingControl;

                  int sel = pbg.getSelected();
                  if (sel != menuItems.length-1)
                     e.key = menuItems[sel].charAt(0);
                  close();
               }
               break;
       }
   }
}