/*
 * The contents of this file are subject to the "Lesser GNU Public License"
 * (LGPL); you may not use this file except in compliance with the License.
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
 * the specific terms governing rights and limitations under the License.
 *
 */

package superwaba.ext.xplat.util.xml;

/** Listener that must be extended to process the events thrown by XmlLiteParser.
  * See also samples/util/xml for an example.
  */

public abstract class HttpXmlListener extends XmlListener
{
    /**
     * This is the method called by parser when the HTTP version is found
     */
    public void foundVersion(){}

    /**
     * This is the method called by parser when HTTP response code is found
     */
    public void foundCode(){}

    /**
     * This is the method called by parser when HTTP response reason is found
     */
    public void foundReason(){}

    /**
     * This is the method called by parser when A HTTP Header name is found
     */
    public void foundHttpHeader(){}

    /**
     * This is the method called by parser when a HTTP Header value is found
     */
    public void foundHttpValue(){}


}
