/*********************************************************************************
 *  SuperWaba Virtual Machine, version 4                                         *
 *  Copyright (C) 2000-2003 Guilherme Campos Hazan <support@superwaba.com.br>    *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  For the purposes of the SuperWaba software we request that software using    *
 *  or linking to the SuperWaba virtual machine or its libraries display the     *
 *  following notice:                                                            *
 *                                                                               *
 *                   Created with SuperWaba                                      *
 *                  http://www.superwaba.org                                     *
 *                                                                               *
 *  Please see the software license located at SuperWabaSDK/license.txt          *
 *  for more details.                                                            *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     Guilherme Campos Hazan                                                    *
 *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22050-000                                                            *
 *     E-mail: support@superwaba.com.br                                          *
 *                                                                               *
 *********************************************************************************/

package waba.fx;

/**
 * Coord is a coordinate with x and y values.
 */

public class Coord
{
   /** x position */
   public int x;
   /** y position */
   public int y;

   /** Constructs a coordinate with all args = 0. */
   public Coord()
   {
      // they are already 0 as default.
   }

   /** Constructs a coordinate with the given x, y. */
   public Coord(int x, int y)
   {
      this.x = x;
      this.y = y;
   }

   /** Translates the current coordinate making x += dx and y += dy */
   public void translate(int dx, int dy)
   {
      x += dx;
      y += dy;
   }

   /** return's x. just to make sense in getSize like methods */
   public int width()
   {
      return x;
   }

   /** return's y. just to make sense in getSize like methods */
   public int height()
   {
      return y;
   }

   public String toString()
   {
      return ""+x+','+y;
   }

   /** Returns true if the coordinates of this Coord and the given one are the same */
   public boolean equals(Object other) // guich@240_2
   {
      if (other instanceof Coord)
      {
         Coord c = (Coord)other;
         return c.x == this.x && c.y == this.y;
      }
      return false;
   }
}