/*********************************************************************************
 *  SuperWaba Virtual Machine, version 4                                         *
 *  Copyright (C) 2000-2003 Guilherme Campos Hazan <support@superwaba.com.br>    *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  For the purposes of the SuperWaba software we request that software using    *
 *  or linking to the SuperWaba virtual machine or its libraries display the     *
 *  following notice:                                                            *
 *                                                                               *
 *                   Created with SuperWaba                                      *
 *                  http://www.superwaba.org                                     *
 *                                                                               *
 *  Please see the software license located at SuperWabaSDK/license.txt          *
 *  for more details.                                                            *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     Guilherme Campos Hazan                                                    *
 *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22050-000                                                            *
 *     E-mail: support@superwaba.com.br                                          *
 *                                                                               *
 *********************************************************************************/

package waba.fx;

/** This class is for internal use only. There are no public methods. */

final public class NativeMethods
{
   ////////////////////////////////////////////////////////////////////////////////////
   native static void fontCreate(Font obj);
   ////////////////////////////////////////////////////////////////////////////////////
   native static void fontMetricsCreate(FontMetrics obj);
   native static int fontMetricsGetCharWidth(FontMetrics obj, char c);
   native static int fontMetricsGetTextWidth(FontMetrics obj, String s);
   native static int fontMetricsGetTextWidth(FontMetrics obj, char chars[], int start, int count);
   ////////////////////////////////////////////////////////////////////////////////////
   native static int []paletteGetCurrentPalette(Palette obj);
   ////////////////////////////////////////////////////////////////////////////////////
   native static void imageCreate(Image obj);
   native static void imageLoad(Image obj, String path);
   native static void imageParse(Image obj, byte []fullBmpDescription);
   native static void imageFree(Image obj);
   native static void imageChangeColors(Image obj, int fromR, int fromG, int fromB, int toR, int toG, int toB);
   native static void imageGetPixelRow(Image obj, byte []fillIn, int y);
   native static void soundBeep();
   native static void soundTone(int freq, int duration);
   native static void soundSetEnabled(boolean on);
   native static waba.fx.Image imageGetScaledInstance(Image obj, int newWidth, int newHeight);
   ////////////////////////////////////////////////////////////////////////////////////
   native static boolean soundClipPlay(SoundClip obj);
}