/*********************************************************************************
 *  SuperWaba Virtual Machine, version 4                                         *
 *  Copyright (C) 2000-2003 Guilherme Campos Hazan <support@superwaba.com.br>    *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  For the purposes of the SuperWaba software we request that software using    *
 *  or linking to the SuperWaba virtual machine or its libraries display the     *
 *  following notice:                                                            *
 *                                                                               *
 *                   Created with SuperWaba                                      *
 *                  http://www.superwaba.org                                     *
 *                                                                               *
 *  Please see the software license located at SuperWabaSDK/license.txt          *
 *  for more details.                                                            *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     Guilherme Campos Hazan                                                    *
 *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22050-000                                                            *
 *     E-mail: support@superwaba.com.br                                          *
 *                                                                               *
 *********************************************************************************/

package waba.fx;

import waba.applet.JavaBridge;
import waba.sys.Vm;
import waba.sys.Settings;
import waba.util.Hashtable;
import waba.fx.Image;

/** This class is for internal use only. There are no public methods. */

final public class NativeMethods4JDK
{
   ////////////////////////////////////////////////////////////////////////////////////
   //                                 waba.fx.Font                                   //
   ////////////////////////////////////////////////////////////////////////////////////
   static void fontCreate(Font obj)
   {
      // do nothing
   }
   ////////////////////////////////////////////////////////////////////////////////////
   //                             waba.fx.FontMetrics                                //
   ////////////////////////////////////////////////////////////////////////////////////
   static void fontMetricsCreate(FontMetrics obj)
   {
      obj.ascent = JavaBridge.getFontMetrics(obj.font).getAscent();
      obj.descent = JavaBridge.getFontMetrics(obj.font).getDescent();
      obj.leading = JavaBridge.getFontMetrics(obj.font).getLeading();
   }
   static int fontMetricsGetCharWidth(FontMetrics obj, char c)
   {
      return JavaBridge.getFontMetrics(obj.font).charWidth(c);
   }
   static int fontMetricsGetTextWidth(FontMetrics obj, String s)
   {
      return JavaBridge.getFontMetrics(obj.font).stringWidth(s);
   }
   static int fontMetricsGetTextWidth(FontMetrics obj, char chars[], int start, int count)
   {
      return fontMetricsGetTextWidth(obj, new String(chars,start,count));
   }
   ////////////////////////////////////////////////////////////////////////////////////
   //                                 waba.fx.Palette                                //
   ////////////////////////////////////////////////////////////////////////////////////
   static final int default256Palette[] =
   {
      0xFFFFFF,0xFFCCFF,0xFF99FF,0xFF66FF,0xFF33FF,0xFF00FF,0xFFFFCC,0xFFCCCC,
      0xFF99CC,0xFF66CC,0xFF33CC,0xFF00CC,0xFFFF99,0xFFCC99,0xFF9999,0xFF6699,
      0xFF3399,0xFF0099,0xCCFFFF,0xCCCCFF,0xCC99FF,0xCC66FF,0xCC33FF,0xCC00FF,
      0xCCFFCC,0xCCCCCC,0xCC99CC,0xCC66CC,0xCC33CC,0xCC00CC,0xCCFF99,0xCCCC99,
      0xCC9999,0xCC6699,0xCC3399,0xCC0099,0x99FFFF,0x99CCFF,0x9999FF,0x9966FF,
      0x9933FF,0x9900FF,0x99FFCC,0x99CCCC,0x9999CC,0x9966CC,0x9933CC,0x9900CC,
      0x99FF99,0x99CC99,0x999999,0x996699,0x993399,0x990099,0x66FFFF,0x66CCFF,
      0x6699FF,0x6666FF,0x6633FF,0x6600FF,0x66FFCC,0x66CCCC,0x6699CC,0x6666CC,
      0x6633CC,0x6600CC,0x66FF99,0x66CC99,0x669999,0x666699,0x663399,0x660099,
      0x33FFFF,0x33CCFF,0x3399FF,0x3366FF,0x3333FF,0x3300FF,0x33FFCC,0x33CCCC,
      0x3399CC,0x3366CC,0x3333CC,0x3300CC,0x33FF99,0x33CC99,0x339999,0x336699,
      0x333399,0x330099,0x00FFFF,0x00CCFF,0x0099FF,0x0066FF,0x0033FF,0x0000FF,
      0x00FFCC,0x00CCCC,0x0099CC,0x0066CC,0x0033CC,0x0000CC,0x00FF99,0x00CC99,
      0x009999,0x006699,0x003399,0x000099,0xFFFF66,0xFFCC66,0xFF9966,0xFF6666,
      0xFF3366,0xFF0066,0xFFFF33,0xFFCC33,0xFF9933,0xFF6633,0xFF3333,0xFF0033,
      0xFFFF00,0xFFCC00,0xFF9900,0xFF6600,0xFF3300,0xFF0000,0xCCFF66,0xCCCC66,
      0xCC9966,0xCC6666,0xCC3366,0xCC0066,0xCCFF33,0xCCCC33,0xCC9933,0xCC6633,
      0xCC3333,0xCC0033,0xCCFF00,0xCCCC00,0xCC9900,0xCC6600,0xCC3300,0xCC0000,
      0x99FF66,0x99CC66,0x999966,0x996666,0x993366,0x990066,0x99FF33,0x99CC33,
      0x999933,0x996633,0x993333,0x990033,0x99FF00,0x99CC00,0x999900,0x996600,
      0x993300,0x990000,0x66FF66,0x66CC66,0x669966,0x666666,0x663366,0x660066,
      0x66FF33,0x66CC33,0x669933,0x666633,0x663333,0x660033,0x66FF00,0x66CC00,
      0x669900,0x666600,0x663300,0x660000,0x33FF66,0x33CC66,0x339966,0x336666,
      0x333366,0x330066,0x33FF33,0x33CC33,0x339933,0x336633,0x333333,0x330033,
      0x33FF00,0x33CC00,0x339900,0x336600,0x333300,0x330000,0x00FF66,0x00CC66,
      0x009966,0x006666,0x003366,0x000066,0x00FF33,0x00CC33,0x009933,0x006633,
      0x003333,0x000033,0x00FF00,0x00CC00,0x009900,0x006600,0x003300,0x111111,
      0x222222,0x444444,0x555555,0x777777,0x888888,0xAAAAAA,0xBBBBBB,0xDDDDDD,
      0xEEEEEE,0xC0C0C0,0x800000,0x800080,0x008000,0x008080,0x000000,0x000000,
      0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,
      0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,
      0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x000000,0x060003
   };

   static int []paletteGetCurrentPalette(Palette obj)
   {
      return Graphics.currentPalette;
   }
   ////////////////////////////////////////////////////////////////////////////////////
   //                                 waba.fx.Image                                  //
   ////////////////////////////////////////////////////////////////////////////////////
   static void imageCreate(Image obj)
   {
      obj.pixels = new int[obj.height][obj.width]; // just create the pixels array
   }

   static Image imageGetScaledInstance(Image obj, int newWidth, int newHeight)
   {
      // guich: a modified version of the replicate scale algorithm.
      int h = newHeight << 1;
      int hi = obj.height << 1;
      int hf = obj.height/h;
      int wf = 0;
      int w = newWidth << 1;
      int wi = obj.width << 1;

      Image scaledImage = new Image(newWidth, newHeight);
      scaledImage.palRGBs = obj.palRGBs;

      int[][] dstImageData = scaledImage.pixels;
      int[][] srcImageData = obj.pixels;

      for (int y=0; y < newHeight; y++,hf+=hi)
      {
         wf = obj.width/w;
         int []dstImageY = dstImageData[y];
         int []srcImageY = srcImageData[hf/h];
         for (int x=0; x < newWidth; x++,wf += wi)
            dstImageY[x] = srcImageY[wf/w];
      }

      return scaledImage;
   }
   public static waba.util.Hashtable htAttachedBitmaps = new waba.util.Hashtable(5);
   static void imageLoad(Image obj, String path)
   {
      byte []bytes = JavaBridge.readBytes(path);
      //   NOTE: we could use the following to read out of an applet's JAR file
      //   if we could get a pathObject which was in the root directory (the
      //   App for example). However, if we don't have one. If we loaded an
      //   image in the App constructor we wouldn't have the App object yet...
      //   if (!isApp)
      //      try
      //         {
      //         Object pathObject = Applet.currentApplet;
      //         stream = pathObject.getClass().getResourceAsStream(path);
      //         }
      //      catch (Exception e) {};

      if (bytes == null)
      {
         // guich@220_9: search in the attached libraries
         waba.io.ByteArrayStream bas = (waba.io.ByteArrayStream)htAttachedBitmaps.get(path.toLowerCase());
         if (bas != null)
            bytes = bas.getBuffer();
         else
         {
            waba.applet.JavaBridge.print("ERROR: can't open image file " + path);
            return;
         }
      }
      try
      {
         ImageLoadBMPCompressed(obj, bytes);
      }
      catch (Exception e)
      {
         waba.applet.JavaBridge.print("ERROR: when loading Image "+path+". Trace appears below.");
         e.printStackTrace();
      }
   }
   static void imageFree(Image obj)
   {
      obj.width = obj.height = 0;
      obj.pixels = null;
   }
   static void imageChangeColors(Image obj, int fromR, int fromG, int fromB, int toR, int toG, int toB)
   {
      int nx = obj.pixels[0].length;
      int ny = obj.pixels.length;
      int cf = new Color(fromR,fromG,fromB).getRGB();
      int ct = new Color(toR,toG,toB).getRGB();
      for (int x = 0; x < nx; x++)
         for (int y =0; y < ny; y++)
            if (obj.pixels[y][x] == cf)
               obj.pixels[y][x] = ct;
   }
   static void imageGetPixelRow(Image obj, byte []fillIn, int y)
   {
      // convert from rgb to the active's palette index
      for (int x =0; x < obj.width; x++) // guich@230_9: changed fillIn.length to obj.width
         fillIn[x] = (byte)obj.savingPal.getColorIndex(new Color(obj.pixels[y][x]));
   }
   static void imageParse(Image obj, byte []fullBmpDescription)
   {
      try
      {
         ImageLoadBMPCompressed(obj, fullBmpDescription);
      }
      catch (Exception e)
      {
         waba.applet.JavaBridge.print("ERROR: when parsing Image with "+fullBmpDescription.length+" bytes. Trace appears below.");
         e.printStackTrace();
      }
   }
   /////////////////// METHODS TAKEN FROM THE SUPERWABA VM ////////////////////
   ////////////////////////////////////////////////////////////////////////////
   /* Floyd/Steinberg error diffusion dithering algorithm in color.  The array
   ** line[][] contains the RGB values for the current line being processed;
   ** line[0][x] = red, line[1][x] = green, line[2][x] = blue.
   */
   // ps: this algorithm was heavily modified and optimized by guich
   // note: dithering an 160x160x256 color bitmap takes about 5 minutes in a palm iiic, so it will only be done in gray scale up to 16 shades.
   private static int GET_RED(int rgb)    {return ((rgb >> 16) & 0xFF);}
   private static int GET_GREEN(int rgb)   {return ((rgb >>  8) & 0xFF);}
   private static int GET_BLUE(int rgb)     {return (rgb & 0xFF);}
   private static boolean doDither;
   private static int []colorTable=null;
   private static int []convPalette;
   private static int bmpW, scale,maxColorIndex,baseIndex;
   private static int []ed;           // Errors distributed down, i.e., to the next line.
   private static int ef[] = new int[3];                  // Error distributed forward.
   private static int ditherPixelGray(int x, int y, int index) // y not used
   {
      int []colors = colorTable;
      int line[] = new int[3];
      int h, c, v;                       // Working variables
      int e0,e1,e2,e3;                   // Error parts (7/8,1/8,5/8,3/8).
      int med;
      int rgb;
      int ind;

      if (x == 0)
         ef[0] = ef[1] = ef[2] = 0;      // No forward error for first dot

      rgb = colorTable[index];
      line[0] = GET_RED(rgb);
      line[1] = GET_GREEN(rgb);
      line[2] = GET_BLUE(rgb);

      for (c=0; c<3; c++)
      {
         v = line[c] + ef[c] + ed[(x << 2) + c];  // Add errors from previous pixels
         if (v > 255) v = 255; else
         if (v < 0) v = 0;                // and clip.
         line[c] = v;
      }

      med = (line[0]+line[1]+line[2]) / 3;
      ind = med >> scale;

      med = (int)(ind + 1) << scale; // make it darker (+1)

      for (c=0; c<3; c++)
      {
         v = line[c]-med;     // V = new error;
         h = v >> 1;          // h = half of v, e[0..3] will be filled with the Floyd and Steinberg weights.
         e0 = (7 * h) >> 3;   // 7/8
         e1 = h - e0;         // 1/8
         h = v - h;           //
         e2 = (5 * h) >> 3;   // 5/8
         e3 = h - e2;         // 3/8

         ef[c] = e0;          // Distribute errors.

         if (x < bmpW) ed[((x+1) << 2) + c] = e1;
         if (x == 0)   ed[(x << 2) + c] = e2; else ed[(x << 2) + c] += e2;
         if (x > 0)    ed[((x-1) << 2) + c] += e3;
      }
      return maxColorIndex - ind;
   }

   private static final void setRGB32(Image obj, int x, int y, int rgb)
   {
      if (0 <= x && x < obj.width && 0 <= y && y < obj.height)
         obj.pixels[y][x] = doDither?convPalette[ditherPixelGray(x,y,rgb)]:colorTable[baseIndex+rgb];//Color.GS_PAL[rgb].getRGB(); //setPixel(x,y,(byte)rgb)
      //to dump to text: System.out.print(" "+rgb); if (x == width-1) waba.applet.JavaBridge.print();
   }

   // readRGB reads in pixels values that are stored uncompressed.
   // The bits represent indices into the color table.
   private static void readRGB(Image obj, int width, int height, int bpp, byte []in, int offset)
   {
      waba.applet.JavaBridge.print("reading "+(doDither?"and dithering ":"")+"rgb "+bpp+"bpp");
      // How many pixels can be stored in a byte?
      int pixelsPerByte = 8 / bpp;
      // A bit mask containing the number of bits in a pixel
      int bitMask = (1 << bpp) - 1;
      int bitShifts[] = new int[8];
      int i,h,w;
      int whichBit = 0;
      int currByte;
      int div = 32 / bpp;

      width = ((width+div-1) / div)*div; // make sure are in a 4 byte boundary - those extra pixels will be stripped off by the current clip

      // The shift values that will move each pixel to the far right
      for (i=0; i < pixelsPerByte; i++)
         bitShifts[i] = 8 - ((i+1) * bpp);

      // Start at the bottom of the pixel array and work up
      if (pixelsPerByte == 1) // guich@200b3: if 8bpp, use a faster routine
         for (h=height-1; h >= 0; h--)
            for (w=0; w < width; w++)
                  setRGB32(obj, w,h,getUnsignedByte(in[offset++]));
      else
      {
         // Read in the first byte
         currByte = getUnsignedByte(in[offset++]);

         // Start at the bottom of the pixel array and work up
         for (h=height-1; h >= 0; h--)
            for (w=0; w < width; w++)
            {
               // Get the next pixel from the current byte
               setRGB32(obj, w,h,(currByte >> bitShifts[whichBit]) & bitMask);
               // If the current bit position is past the number of pixels in a byte, you advance to the next byte
               if (++whichBit >= pixelsPerByte)
               {
                  whichBit = 0;
                  if (offset < in.length)
                     currByte = getUnsignedByte(in[offset++]);
               }
            }
      }
   }
   private static int getUnsignedByte(byte b)
   {
      return ((int)b) & 0xFF;
   }
   private static void readRLE(Image obj, int height, byte []in, int offset, boolean rle8)
   {
      int val;
      int len,esc;
      int   x,y;

      x = 0;
      y = height-1;

      waba.applet.JavaBridge.print("reading "+(doDither?"and dithering ":"")+(rle8?"rle8":"rle4"));

      while (true)
      {
         esc = getUnsignedByte(in[offset++]);
         // encoded mode starts with a run length, and then a byte with two colour indexes to alternate between for the run
         if (esc != 0)
         {
               if (rle8)
               {
                  int color = getUnsignedByte(in[offset++]);
                  while (esc-- > 0)
                     setRGB32(obj, x++,y,color);
               }
               else
               {
                  int colors0,colors1;
                  val = getUnsignedByte(in[offset++]);
                  colors0 = (val>>4) & 0x0f;
                  colors1 = val & 0x0f;
                  for (len = 0; len < esc; len++, x++)
                     setRGB32(obj, x, y, ((len & 1) != 0)?colors1:colors0); // odd count, low nybble
               }
         }
         else // A leading zero is an escape; it may signal the end of the bitmap, a cursor move, or some absolute data.
         {    // zero tag may be absolute mode or an escape
               esc = getUnsignedByte(in[offset++]);
               switch (esc)
               {
                  case 0:                             // end of line
                     x = 0; y--;
                     break;
                  case 1:                             // end of bitmap
                     return;
                  case 2:                             // delta
                     x += getUnsignedByte(in[offset++]);
                     y -= getUnsignedByte(in[offset++]);
                     break;
                  default:        // no compression
                     if (rle8)
                     {
                        len = esc;
                        while (len-- > 0)
                           setRGB32(obj, x++,y,getUnsignedByte(in[offset++]));
                        if ((esc & 1) != 0) // Must have even nunber of bytes
                           offset++;
                     }
                     else
                     {
                        for (len = 0; len < esc; len++, x++)
                        {
                           val = getUnsignedByte(in[offset]);
                           if ((len & 1) != 0)
                           {
                              val &= 0xf;      // get low nybble
                              offset++;            // byte with nybbles
                           }
                           else
                              val >>= 4;       // get high nybble
                           setRGB32(obj, x, y, val);
                        }
                        if (((len >> 1) & 1) != 0) // not padded in 2 bytes boudary?
                           offset++;
                     }
                     break;
               }
         }
      }
   }

   // Intel architecture getUInt16
   private static int inGetUint16(byte bytes[], int off)
   {
      return ((bytes[off+1] & 0xFF) << 8) | (bytes[off] & 0xFF);
   }
   // Intel architecture getUInt32
   private static int inGetUint(byte bytes[], int off)
   {
      return ((bytes[off + 3] & 0xFF) << 24) | ((bytes[off + 2] & 0xFF) << 16) | ((bytes[off + 1] & 0xFF) << 8) | (bytes[off] & 0xFF);
   }

   // created by guich to handle all types of modern bitmaps,
   private static final int BI_RGB  = 0;
   private static final int BI_RLE8 = 1;
   private static final int BI_RLE4 = 2;
   private static void ImageLoadBMPCompressed(Image obj, byte []p)
   {
      int bitmapOffset, infoSize, color;
      int compression, imageSize,usedColors;
      boolean storePalette;

      int maxColors = Settings.maxColors;
      boolean isColor = Settings.isColor;
      int displayBPP = waba.applet.Applet.bpp; // guich@200b4_71
      boolean confirmDithering;

      // header (54 bytes)
      // 0-1   magic chars 'BM'
      // 2-5   uint filesize (not reliable)
      // 6-7   uint16 0
      // 8-9   uint16 0
      // 10-13 uint bitmapOffset
      // 14-17 uint info size
      // 18-21 int  width
      // 22-25 int  height
      // 26-27 uint16 nplanes
      // 28-29 uint16 bits per pixel
      // 30-33 uint compression flag
      // 34-37 uint image size in bytes
      // 38-41 int  biXPixelsPerMeter
      // 42-45 int  biYPixelsPerMeter
      // 46-49 uint colors used
      // 50-53 uint important color count
      // 54-   uchar  bitmap bytes depending to type
      // Each scan line of image data is padded to the next four byte boundary

      if (p[0] != 'B' || p[1] != 'M')
      {
         waba.applet.JavaBridge.print("Error in Image: not a bmp file!");
         return; // not a BMP file
      }
      bitmapOffset = inGetUint(p,10);
      infoSize = inGetUint(p,14);
      if (infoSize != 40)
      {
         waba.applet.JavaBridge.print("Error in Image: old style bmp");
         return; // old-style BMP
      }
      obj.width = inGetUint(p,18);
      obj.height = inGetUint(p,22);
      if (obj.width > 65535 || obj.height > 65535 || obj.width <= 0 || obj.height <= 0)
      {
         waba.applet.JavaBridge.print("Error in Image: bad width/height");
         return;
      }
      int bmpBPP = inGetUint16(p,28);
      if (bmpBPP == 24)
      {
         waba.applet.JavaBridge.print("Error in Image: support for 24 bits bitmap was removed because the pics gets too large");
         return;
      }
      compression = inGetUint(p,30);
      imageSize = inGetUint(p,34);
      usedColors = inGetUint(p,46);
      if (usedColors == 0) usedColors = 1 << bmpBPP;

      bmpW = obj.width-1;

      baseIndex    = (displayBPP >= 8 && usedColors == 16) ? 231 : 0; // if in color device and the image has 16 colors, store the colors in the user defined colors region
      doDither     =  displayBPP <  8 && bmpBPP > displayBPP; // this is the normal situation.
      confirmDithering = displayBPP < 8; // But if we have a 16 colors bitmap in a 16 gray device, we also must do dithering. So, we must confirm that this bmp has a gray palette.
      storePalette = displayBPP >= 8 && !doDither;
      colorTable   = new int[(storePalette ? 256 : (1 << bmpBPP)/*usedColors*/)]; // guich@300_14: removed 4*... (an int already has 4 bytes) - guich@340_59: in some bitmaps, colorsUsed may be smaller than the number of possible colors, but the bitmap may still have indexes greater than the usedColors, thus making the bitmap appear black. To avoid this, we always allocate 1<<BPP
      if (storePalette && usedColors != 256)
         Vm.copyArray(/*SystemPalette*/default256Palette,0,colorTable,0,256); // copy the system palette - guich@300_14: changed 1024 to 256 (number of ints, not number of bytes)

      // Read the bitmap's color table
      for (int i=0,j=54; i < usedColors; i++,j+=4)
      {
         colorTable[baseIndex+i] = color = (inGetUint(p,j) & 0x00FFFFFF);
         if (confirmDithering && !doDither && (GET_RED(color) != GET_GREEN(color) || GET_RED(color) != GET_BLUE(color)))
            doDither = true;
      }

      if (!isColor || doDither)
         if (maxColors == 16)
            {convPalette = Palette.default16PaletteScr2Dev; scale = 4; maxColorIndex = 15;}
         else
            {convPalette = Palette.default4PaletteScr2Dev; scale = 6; maxColorIndex =  3;}

      // prepares the color table for this screen bpp.
      if (bmpBPP == 1 && colorTable[0] == 0xFFFFFF) // the bitmap is monochrome, are the colors iverted?
      {
         colorTable[1] = 0xFFFFFF;
         colorTable[0] = 0x000000;
      }
     /* if (storePalette)
      {
         GRHANDLE_PaletteSize(imgHandle) = 256;
         GRHANDLE_Palette(imgHandle) = colorTable;
      }*/

      // Create space for the pixels
      obj.pixels = new int[obj.height][obj.width];

      ed = null;
      if (doDither)
         ed = new int[(bmpW+1)*4]; // must be zeroed!

      // Read the pixels from the stream based on the compression type directly into the selected offscreen image
      if (compression == BI_RGB)
         readRGB(obj, obj.width, obj.height, bmpBPP, p, bitmapOffset);
      else
         readRLE(obj, obj.height, p, bitmapOffset, compression == BI_RLE8);

      if (isColor)
         obj.palRGBs = colorTable;
      ed = null;
   }
   ////////////////////////////////////////////////////////////////////////////////////
   //                                waba.fx.Sound                                   //
   ////////////////////////////////////////////////////////////////////////////////////
   private static boolean toneErrDisplayed = false;
   private static boolean soundEnabled = true;
   static void soundBeep()
   {
      if (soundEnabled)
         waba.applet.JavaBridge.beep();
   }
   static void soundTone(int freq, int duration)
   {
      if (!toneErrDisplayed)
      {
         soundBeep();
         waba.applet.JavaBridge.print("NOTICE: tones aren't supported under Java");
         toneErrDisplayed = true;
      }
   }
   static void soundSetEnabled(boolean on)
   {
      soundEnabled = on;
   }
   ////////////////////////////////////////////////////////////////////////////////////
   //                               waba.fx.SoundClip                                //
   ////////////////////////////////////////////////////////////////////////////////////
   private static Hashtable htClips = new Hashtable(10);
   static boolean soundClipPlay(SoundClip obj)
   {
      java.applet.AudioClip audioClip = null;
      if (!obj.loaded)
      {
         waba.applet.Applet applet = waba.applet.Applet.currentApplet;
         if (!applet.isApplication)
         {
            try
            {
               audioClip = applet.getAudioClip(applet.getCodeBase(), obj.path);
            }
            catch (Exception e) { e.printStackTrace(); }
            if (audioClip != null)
               htClips.put(obj,audioClip);
         }
         else waba.applet.JavaBridge.print("Applications can't play clips! Only Applets can.");
         obj.loaded = true;
      }
      audioClip = (java.applet.AudioClip)htClips.get(obj);
      if (audioClip == null)
         return false;
      audioClip.play();
      return true;
   }
}