/*********************************************************************************
 *  SuperWaba Virtual Machine, version 4                                         *
 *  Copyright (C) 2000-2003 Guilherme Campos Hazan <support@superwaba.com.br>    *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  For the purposes of the SuperWaba software we request that software using    *
 *  or linking to the SuperWaba virtual machine or its libraries display the     *
 *  following notice:                                                            *
 *                                                                               *
 *                   Created with SuperWaba                                      *
 *                  http://www.superwaba.org                                     *
 *                                                                               *
 *  Please see the software license located at SuperWabaSDK/license.txt          *
 *  for more details.                                                            *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     Guilherme Campos Hazan                                                    *
 *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22050-000                                                            *
 *     E-mail: support@superwaba.com.br                                          *
 *                                                                               *
 *********************************************************************************/

package waba.io;

/** This class is for internal use only. There are no public methods. */

final public class NativeMethods
{
   ////////////////////////////////////////////////////////////////////////////////////
   native static void serialPortCreate(SerialPort obj, int number, int baudRate, int bits, boolean parity, int stopBits);
   native static boolean serialPortClose(SerialPort obj);
   native static boolean serialPortIsOpen(SerialPort obj);
   native static boolean serialPortSetFlowControl(SerialPort obj, boolean on);
   native static boolean serialPortSetReadTimeout(SerialPort obj, int millis);
   native static int serialPortReadBytes(SerialPort obj, byte buf[], int start, int count);
   native static int serialPortReadCheck(SerialPort obj);
   native static int serialPortWriteBytes(SerialPort obj, byte buf[], int start, int count);
   ////////////////////////////////////////////////////////////////////////////////////
   native static void socketCreate(Socket obj, String host, int port, int timeout, boolean noLinger);
   native static boolean socketClose(Socket obj);
   native static boolean socketIsOpen(Socket obj);
   native static boolean socketSetReadTimeout(Socket obj, int millis);
   native static int socketReadBytes(Socket obj, byte buf[], int start, int count);
   native static int socketWriteBytes(Socket obj, byte buf[], int start, int count);
   native static boolean socketDisconnect();
   ////////////////////////////////////////////////////////////////////////////////////
   native static void catalogCreate(Catalog obj, String name, int mode);
   native static boolean catalogRename(Catalog obj, String newName);
   native static int catalogAddRecord(Catalog obj, int size);
   native static int catalogAddRecord(Catalog obj, int size, int pos);
   native static boolean catalogResizeRecord(Catalog obj, int size);
   native static boolean catalogClose(Catalog obj);
   native static boolean catalogDelete(Catalog obj);
   native static String []catalogListCatalogs(int creatorId, int type);
   native static boolean catalogDeleteRecord(Catalog obj);
   native static int catalogGetRecordCount(Catalog obj);
   native static int catalogGetRecordSize(Catalog obj);
   native static boolean catalogIsOpen(Catalog obj);
   native static boolean catalogSetRecordPos(Catalog obj, int pos);
   native static int catalogReadBytes(Catalog obj, byte buf[], int start, int count);
   native static int catalogSkipBytes(Catalog obj, int count);
   native static int catalogWriteBytes(Catalog obj, byte buf[], int start, int count);
   native static int catalogInspectRecord(Catalog obj, byte buf[], int recPosition);
   native static byte catalogGetRecordAttributes(Catalog obj, int recordPos);
   native static void catalogSetRecordAttributes(Catalog obj, int recordPos, byte attr);
   native static int catalogGetAttributes(Catalog obj);
   native static void catalogSetAttributes(Catalog obj, int i);
   native static int catalogGetRecordPos(Catalog obj);
   native static void catalogCreate(Catalog obj);
   ////////////////////////////////////////////////////////////////////////////////////
   native static boolean fileIsAvailable();
   native static void fileCreate(File file, String path, int mode);
   native static boolean fileClose(File obj);
   native static boolean fileCreateDir(File obj);
   native static boolean fileDelete(File obj);
   native static boolean fileExists(File obj);
   native static int fileGetSize(File obj);
   native static boolean fileIsDir(File obj);
   native static boolean fileIsOpen(File obj);
   native static String []fileListFiles(File obj);
   native static int fileReadBytes(File obj, byte b[], int off, int len);
   native static boolean fileRename(File obj, String path);
   native static boolean fileSetPos(File obj, int pos);
   native static int fileWriteBytes(File obj, byte b[], int off, int len);
   native static void fileSetAttributes(File obj, int attr);
   native static int fileGetAttributes(File obj);
   native static void fileSetTime(File obj, byte whichTime, waba.sys.Time time);
   native static waba.sys.Time fileGetTime(File obj, byte whichTime);
}