/*********************************************************************************
 *  SuperWaba Virtual Machine, version 4                                         *
 *  Copyright (C) 2000-2003 Guilherme Campos Hazan <support@superwaba.com.br>    *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  For the purposes of the SuperWaba software we request that software using    *
 *  or linking to the SuperWaba virtual machine or its libraries display the     *
 *  following notice:                                                            *
 *                                                                               *
 *                   Created with SuperWaba                                      *
 *                  http://www.superwaba.org                                     *
 *                                                                               *
 *  Please see the software license located at SuperWabaSDK/license.txt          *
 *  for more details.                                                            *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     Guilherme Campos Hazan                                                    *
 *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22050-000                                                            *
 *     E-mail: support@superwaba.com.br                                          *
 *                                                                               *
 *********************************************************************************/

package waba.sys;

/** This class is for internal use only. There are no public methods. */

final public class NativeMethods
{
   ////////////////////////////////////////////////////////////////////////////////////
   native static int convertToInt(String s);
   native static String convertToString(char c);
   native static int convertToIntBitwise(float f);
   native static float convertToFloatBitwise(int i);
   native static String convertToString(float f);
   native static String convertToString(int i);
   native static String convertToString(double d, int precision);
   native static double convertToDouble(String s);
   native static String convertToString(float f, int d);
   native static float convertToFloat(String s);
   native static String convertToString(String doubleValue, int n);
   native static long convertDoubleToLongBits(double value);
   native static double convertDoubleFromLongBits(long bits);
   ////////////////////////////////////////////////////////////////////////////////////
   native static void timeCreate(Time obj);
   ////////////////////////////////////////////////////////////////////////////////////
   native static boolean vmCopyArray(Object srcArray, int srcStart, Object dstArray, int dstStart, int length);
   native static int vmGetTimeStamp();
   native static void vmSetTimeStamp(waba.sys.Time t);
   native static void vmExitAndReboot();
   native static int vmExec(String command, String args, int launchCode, boolean wait);
   native static int vmSetDeviceAutoOff(int seconds);
   native static void vmSleep(int millis);
   native static int vmGetDeviceFreeMemory();
   native static void vmInterceptSystemKeys(int keys);
   native static void vmDebug(String s);
   native static void vmSetTrace(boolean on);
   native static void vmClipboardCopy(String s);
   native static String vmClipboardPaste();
   native static boolean vmAttachLibrary(String name);
   native static boolean vmAttachNativeLibrary(String name);
   native static int vmGetSystemKeysPressed(); // guich@200b4_7
   native static void vmGC(); // guich@200b4_159
   ////////////////////////////////////////////////////////////////////////////////////
}