/*********************************************************************************
 *  SuperWaba Virtual Machine, version 4                                         *
 *  Copyright (C) 2000-2003 Guilherme Campos Hazan <support@superwaba.com.br>    *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  For the purposes of the SuperWaba software we request that software using    *
 *  or linking to the SuperWaba virtual machine or its libraries display the     *
 *  following notice:                                                            *
 *                                                                               *
 *                   Created with SuperWaba                                      *
 *                  http://www.superwaba.org                                     *
 *                                                                               *
 *  Please see the software license located at SuperWabaSDK/license.txt          *
 *  for more details.                                                            *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     Guilherme Campos Hazan                                                    *
 *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22050-000                                                            *
 *     E-mail: support@superwaba.com.br                                          *
 *                                                                               *
 *********************************************************************************/

package waba.sys;

import waba.applet.Applet;
import java.awt.datatransfer.*;
import java.awt.Toolkit;

/** This class is for internal use only. There are no public methods. */

final public class NativeMethods4JDK
{
   static
   {
      /* guich@200b4_150: waba.sys.NativeMethods4JDK is always the first NativeMethod
       * class created. It may have been created by a compiler or by Retroguard
       * during the obfuscating process. When it is created this way, the
       * waba.applet.Applet was not initialized, and such here we test and
       * create it if necessary. The values in the class aren't important; but
       * they must not be null.
       */
      if (waba.applet.Applet.currentApplet == null)
      {
         //System.out.println("CREATING DUMMY waba.applet.Applet");
         new waba.applet.Applet();
      }
   }
   ////////////////////////////////////////////////////////////////////////////////////
   //                                  waba.sys.Convert                              //
   ////////////////////////////////////////////////////////////////////////////////////
   static int convertToInt(String s)
   {
      int i = 0;
      try { i = java.lang.Integer.parseInt(s); }
         catch (Exception e) {}
      return i;
   }
   static String convertToString(char c)
   {
      return "" + c;
   }
   static int convertToIntBitwise(float f)
   {
      return Float.floatToIntBits(f);
   }
   static float convertToFloatBitwise(int i)
   {
      return Float.intBitsToFloat(i);
   }
   static String convertToString(float f)
   {
      return java.lang.Float.toString(f);
   }
   static String convertToString(int i)
   {
      return java.lang.Integer.toString(i);
   }
   static double rounds[] = {5e-1,5e-2,5e-3,5e-4,5e-5,5e-6,5e-7,5e-8,5e-9,5e-10,5e-11,5e-12,5e-13,5e-14,5e-15,5e-16,5e-17,5e-18};

   /////// double routines from VM //////////////////////////////////
   private static final long POSITIVE_INFINITY_VALUE = 0x7ff0000000000000L;
   private static final long NEGATIVE_INFINITY_VALUE = 0xfff0000000000000L;
   private static final char negSign = '-',plusSign = '+', decimalPoint = '.';
   private static final byte EXP_NOTATION = 0x10;
   private static final byte NO_EXP_NOTATION = 0x20;

   private static final double LN10 = 2.3025850929940455;
   private static final double MAX_FLOAT = 1.15292150460684698E18; // pow(2,60);
   private static final double MIN_FLOAT = 8.881784197001252E-16;  // pow(2,-50);

   private static long bits(double val)
   {
      return Double.doubleToLongBits(val);
   }
   private static final String Infinity = "Inf";
   private static final String NaN = "NaN";
   private static final int MAX_DECIMALS = 15; // DONT CHANGE THIS!

   private static String reverse(StringBuffer dest)
   {
      char []tempSrc = dest.toString().toCharArray();
      char []tempDst = new char[tempSrc.length];
      for (int j = 0; j < tempSrc.length; j++)
         tempDst[tempSrc.length-1-j] = tempSrc[j];
      dest.setLength(0);
   	return new String(tempDst);
   }

   private static void doubleToStr(StringBuffer dest,double val,int totalLength,int decimal, int options)
   {
	   boolean neg = val<0;
	   if (neg) val *= -1;

	   if (Double.isNaN(val))
	   {
		   dest.append(NaN);
		   return;
	   } else
	   if (bits(val) == POSITIVE_INFINITY_VALUE || bits(val) == NEGATIVE_INFINITY_VALUE)
	   {
	      dest.append(neg?'-':'+');
	      dest.append(Infinity);
		   return;
	   }

	   if (val != 0)
   	   // Should we do Sci. Notation?
   	   if (((val >= MAX_FLOAT  || val <= MIN_FLOAT || ((options & EXP_NOTATION) != 0)) && ((options & NO_EXP_NOTATION) == 0)))
   	   {
   	      // Have to do e version.
   		   double power = Math.log(val)/LN10;
   		   double man;
   		   boolean negpow = power < 0;
   		   if (negpow) power *= -1;
   		   if (negpow)
   		   {
   			   man = 1-(power-(long)power);
   			   power = (double)(1+(long)power);
   			   if (man >= 1)
   			   {
   				   man -= 1;
   				   power -= 1;
   			   }
   		   }
   		   else
   		   {
   			   man = power-(long)power;
   			   power = (double)(long)power;
   		   }
   		   man = Math.pow(10,man);
   		   if (neg) man *= -1;
   		   if (totalLength == 0)
   			   doubleToStr(dest,man,0,decimal,options|NO_EXP_NOTATION);
   		   else
   			   doubleToStr(dest,man,1,0,options|NO_EXP_NOTATION);
   		   //while(*dest != 0) dest++;
   		   dest.append('e');
   		   dest.append(negpow ? negSign : plusSign);
   		   dest.append(""+(int)power); // use java's int2str. it works
   		   return;
   	   }
      ///// end of EWE stuff ////
      double d;
      long i;
      int n;
      boolean floatingPoint = decimal < 0;

      i = (long)val;
      d = (val - (double)i);
      if (d != 0)
      {
         if (floatingPoint) // free flow
         {
            double temp = d;
   		   for (n = 1; n <= MAX_DECIMALS; n++)
   		   {
   			   temp *= 10.0;
   			   if (temp >= 1.0) decimal = n;
   			   temp -= (long)temp;
   		   }
   		   if (decimal == MAX_DECIMALS) // 12.04 = 12 + 0.03999999.... in this case, we just round it and try again
   		   {
               d += rounds[MAX_DECIMALS];
               temp = d;
      		   for (n = 1; n <= MAX_DECIMALS; n++)
      		   {
      			   temp *= 10.0;
      			   if (temp >= 1.0) decimal = n;
      			   temp -= (long)temp;
      		   }
            }
         }

         if (decimal > MAX_DECIMALS) decimal = MAX_DECIMALS;
         d += rounds[decimal];
         if (d > 1.0d)
         {
            i += (long)d; // guich@240_5
            d -= 1.0d;
         }
      }
      // convert integer part
      do
      {
         n = (int)(i % 10);
         dest.append((char)('0'+n));
         i /= 10;
      } while (i > 0);
      // reverse the string
      String s = reverse(dest);
      if (neg) // make it negative
         dest.append(negSign);
      dest.append(s);
      // convert the decimal part
      if (decimal > 0)
      {
         dest.append(decimalPoint);
         while (decimal-- > 0)
         {
            d *= 10;
            n = (int)d%10;
            dest.append((char)('0'+n));
            d -= n; // dont let the number grow above 10
         }
         if (floatingPoint) // if floating point, strip out the leading zeros
         {
            char []temp = dest.toString().toCharArray();
            n = temp.length;
            while (temp[n-1] == '0')
               n--;
            if (temp[n-1] == '.')
            if (n != temp.length)
            {
               dest.setLength(0);
               dest.append(temp);
            }
         }
      }
   }

   /** Converts the given double to a String, formatting it with <precision> decimal places.
   @since 2.0 */
   static String convertToString(double doubleValue, int precision)
   {
      //if (precision < 0)
        // return doubleValue+""; // use java's underlying string conversion.
      StringBuffer buf = new StringBuffer(40);
      doubleToStr(buf,doubleValue,0,precision,0);
      return buf.toString();
   }

/*      boolean neg = doubleValue < 0;
      if (neg) doubleValue = -doubleValue;
      long i = (long)doubleValue;
      double d = (doubleValue - (double)i);
      double r = rounds[precision];
      d += r;
      long n;
      StringBuffer sb = new StringBuffer(30);
      // convert integer part
      do
      {
         n = i % 10;
         sb.append((char)('0'+n));
         i /= 10;
      } while (i > 0);
      if (neg) sb.append('-');
      // reverse the string
      char []tempSrc = sb.toString().toCharArray();
      char []tempDst = new char[tempSrc.length];
      for (int j = 0; j < tempSrc.length; j++)
         tempDst[tempSrc.length-1-j] = tempSrc[j];
      sb.setLength(0);
      sb.append(new String(tempDst));
      // convert the decimal part
      if (precision > 0)
      {
         sb.append('.');
         while (precision-- > 0)
         {
            d *= 10;
            n = (int)d%10;
            sb.append((char)('0'+n));
            d -= n; // dont let the number grow above 10
         }
      }
      return sb.toString();
   */

   static double convertToDouble(String s)
   {
      try
      {
         double d = Double.valueOf(s).doubleValue();
         return d;
      }
      catch (Exception e)
      {
         return 0;
      }
   }
   static String convertToString(float f, int d)
   {
      return convertToString((double)f, d);
   }
   static float convertToFloat(String s)
   {
      try
      {
         return Float.valueOf(s).floatValue();
      }
      catch (Exception e)
      {
         return 0;
      }
   }
   static String convertToString(String doubleValue, int n)
   {
      return convertToString(convertToDouble(doubleValue), n);
   }
   static long convertDoubleToLongBits(double value)
   {
      return Double.doubleToLongBits(value);
   }
   static double convertDoubleFromLongBits(long bits)
   {
      return Double.longBitsToDouble(bits);
   }
   ////////////////////////////////////////////////////////////////////////////////////
   //                                 waba.sys.Time                                  //
   ////////////////////////////////////////////////////////////////////////////////////
   static void timeCreate(Time obj)
   {
	   waba.applet.JavaBridge.fillTime(obj);
   }
   ////////////////////////////////////////////////////////////////////////////////////
   //                                 waba.sys.Vm                                    //
   ////////////////////////////////////////////////////////////////////////////////////
   static boolean vmCopyArray(Object srcArray, int srcStart, Object dstArray, int dstStart, int length)
   {
	   if (length < 0)
		   return false;
	   try
	   {
		   System.arraycopy(srcArray, srcStart, dstArray, dstStart, length);
	   }
	   catch (Exception e)
	   {
	      waba.applet.JavaBridge.print("Exception thrown in vmCopyArray: "+e.getMessage());
   	   return false;
	   }
	   return true;
	}
	static void vmSetTimeStamp(waba.sys.Time t)
	{
	   waba.applet.JavaBridge.print("setTimeStamp does not work in JDK");
	}
   static int vmGetTimeStamp()
   {
	   return (int)(System.currentTimeMillis() % (1 << 30));
   }
   static void vmExitAndReboot()
   {
      waba.ui.MainWindow.getMainWindow().exit(0);
   }
   static int vmExec(String command, String args, int launchCode, boolean wait)
   {
      int status = -1;
	   try
	   {
	      if (launchCode == -1) // guich@120
	      {
            // guich@120: the ideal were that all classes should be re-instantiated, because any static methods that used the last MainWindow are now pointing to invalid data.
            Class c = Class.forName(command);
            Applet.currentApplet.commandLine = args; // guich@200b3: added command line support for desktop classes.
            Applet.currentApplet.destroyCurrentMainWindow();
            Applet.currentApplet.mainWindow = (waba.ui.MainWindow)c.newInstance();
            Applet.currentApplet.mainWindow.onStart(); // ps: since we are being called from an app, we cannot use the synchronized method
            status = 0;
         }
         else
         {
   	      java.lang.Runtime runtime = java.lang.Runtime.getRuntime();
		      java.lang.Process p = runtime.exec(command + " " + args);
		      if (wait)
			      status = p.waitFor();
		      else
			      status = 0;
	      }
	   }
      catch (Exception e) {e.printStackTrace();}
	   return status;
   }
   // guich: never knew why Rick added this to superwaba. maybe in pc it could reboot the system... ;-)))
   static int vmSetDeviceAutoOff(int seconds)
   {
	   return 0;
   }
   static void vmSleep(int millis)
   {
	   try
	   {
		   java.lang.Thread.currentThread().sleep(millis);
	   }
	   catch (InterruptedException e) {}
   }
   static void vmGC()
   {
      Runtime.getRuntime().gc();
   }
   static int vmGetDeviceFreeMemory()
   {
      return (int)Runtime.getRuntime().freeMemory();
   }
   static void vmInterceptSystemKeys(int keys)
   {
      // nothing to do.
   }
   static int vmGetSystemKeysPressed() // guich@200b4_7
   {
      return waba.applet.WinCanvas.currentCanvas.currentKeysState;
   }
   static void vmDebug(String s)
   {
	   System.err.println(System.currentTimeMillis()+" - "+s); // alexmuc@400_63
   }
   static void vmSetTrace(boolean on)
   {
      Runtime.getRuntime().traceMethodCalls(on);
   }
	private static ClipboardOwner defaultClipboardOwner = new ClipboardObserver();
	static class ClipboardObserver implements ClipboardOwner
	{
		public void lostOwnership(Clipboard clipboard, Transferable contents)
		{
		}
	}
   static void vmClipboardCopy(String s)
   {
	   Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
	   StringSelection contents = new StringSelection(s);
	   clipboard.setContents(contents, defaultClipboardOwner);
   }
   static String vmClipboardPaste()
   {
	   Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
	   Transferable content = clipboard.getContents(defaultClipboardOwner);
	   if (content != null)
	   {
		   try
		   {
			   String dstData = (String) (content.getTransferData(DataFlavor.stringFlavor));
			   return dstData;
		   }
		   catch (Exception e)
		   {
			   return "";
		   }
	   }
	   return "";
   }
   static boolean vmAttachLibrary(String name)
   {
      boolean found = false;
      if (name.indexOf('.') == -1)
      {
         waba.applet.JavaBridge.print("NOTE: in desktop, you must use Vm.attachLibrary(\"name.CRTR\"), otherwise the library will not be found");
         return false;
      }
      name += ".SWAX"; // append the type
      java.io.File f = new java.io.File(".",name.substring(0,name.indexOf('.'))+".pdb");
      if (f.canRead())
      {
         // open the assigned Catalog
         waba.io.Catalog cat = new waba.io.Catalog(name,waba.io.Catalog.READ_ONLY);
         if (cat.isOpen())
         {
            int n = cat.getRecordCount();
            for (int j =0; j < n; j++) // find the correct position to insert the record. the records must be sorted
            {
               cat.setRecordPos(j);
               waba.io.DataStream ds = new waba.io.DataStream(cat);
               String recName = ds.readString();
               if (recName.endsWith(".bmp"))
               {
                  int size = cat.getRecordSize()-recName.length()-2;
                  waba.io.ByteArrayStream bas = new waba.io.ByteArrayStream(size);
                  cat.readBytes(bas.getBuffer(),0,size);
                  waba.fx.NativeMethods4JDK.htAttachedBitmaps.put(recName,bas);
                  waba.applet.JavaBridge.print("Image found in library: "+recName);
                  found = true;
               }
            }
         }
      }
      return found;
   }
   static boolean vmAttachNativeLibrary(String name)
   {
      vmDebug("attachNativeLibrary is impossible in JDK");
      return false;
   }
}