/*********************************************************************************
 *  SuperWaba Virtual Machine, version 4                                         *
 *  Copyright (C) 2000-2003 Guilherme Campos Hazan <support@superwaba.com.br>    *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  For the purposes of the SuperWaba software we request that software using    *
 *  or linking to the SuperWaba virtual machine or its libraries display the     *
 *  following notice:                                                            *
 *                                                                               *
 *                   Created with SuperWaba                                      *
 *                  http://www.superwaba.org                                     *
 *                                                                               *
 *  Please see the software license located at SuperWabaSDK/license.txt          *
 *  for more details.                                                            *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     Guilherme Campos Hazan                                                    *
 *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22050-000                                                            *
 *     E-mail: support@superwaba.com.br                                          *
 *                                                                               *
 *********************************************************************************/

package waba.sys;

/** A simple <b>non-preemptive</b> thread model. Does not support any type of concurrency. The run
  * method is called when the system is idle, and it must be simple and return as
  * fast as possible, because it blocks the VM.
  * <b>Important:</b> the <code>synchronized</code> keyword is not implemented by
  * the SuperWaba VM.
  * Note that in PalmOS while the user is writting in the grafitti area all events
  * (including threads) are blocked (this is a Operating System behaviour).
  */
public interface Thread
{
   /* The run method is called when the system is idle, and it must be simple
    * and return as fast as possible, because it blocks the VM.
    * Use the MainWindow methods addThread and removeThread to start and stop it.
    */
   public void run();

   /** Called just before the thread is started */
   public void started();

   /** Called just after the thread is stopped */
   public void stopped();

}