/*********************************************************************************
 *  SuperWaba Virtual Machine, version 4                                         *
 *  Copyright (C) 2000-2003 Guilherme Campos Hazan <support@superwaba.com.br>    *
 *  Copyright (C) 1998, 1999 Wabasoft <www.wabasoft.com>                         *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  For the purposes of the SuperWaba software we request that software using    *
 *  or linking to the SuperWaba virtual machine or its libraries display the     *
 *  following notice:                                                            *
 *                                                                               *
 *                   Created with SuperWaba                                      *
 *                  http://www.superwaba.org                                     *
 *                                                                               *
 *  Please see the software license located at SuperWabaSDK/license.txt          *
 *  for more details.                                                            *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     Guilherme Campos Hazan                                                    *
 *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22050-000                                                            *
 *     E-mail: support@superwaba.com.br                                          *
 *                                                                               *
 *********************************************************************************/

package waba.ui;

/**
 * ControlEvent is an event posted by a control.
 */

public class ControlEvent extends Event
{
   /** The event type for a pressed event. */
   public static final int PRESSED = 300;
   /** The event type for a focus in event. */
   public static final int FOCUS_IN = 301;
   /** The event type for a focus out event. */
   public static final int FOCUS_OUT = 302;
   /** The event type for a timer event. */
   public static final int TIMER = 303;
   /** The event type for a closing window. */
   public static final int WINDOW_CLOSED = 499;
   /** The event type for a recently moved window. This indicate that all the Graphic objects must be translated or reinitialized. */
   public static final int WINDOW_MOVED = 498;

   public ControlEvent()
   {
   }

   /**
   * Constructs a control event of the given type.
   * @param type the type of event
   * @param c the target control
   */
   public ControlEvent(int type, Control c)
   {
      this.type = type;
      target = c;
   }
}
