/*********************************************************************************
 *  SuperWaba Virtual Machine, version 4                                         *
 *  Copyright (C) 2000-2003 Guilherme Campos Hazan <support@superwaba.com.br>    *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  For the purposes of the SuperWaba software we request that software using    *
 *  or linking to the SuperWaba virtual machine or its libraries display the     *
 *  following notice:                                                            *
 *                                                                               *
 *                   Created with SuperWaba                                      *
 *                  http://www.superwaba.org                                     *
 *                                                                               *
 *  Please see the software license located at SuperWabaSDK/license.txt          *
 *  for more details.                                                            *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     Guilherme Campos Hazan                                                    *
 *     Av. Nossa Senhora de Copacabana 728 apto 605 - Copacabana                 *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22050-000                                                            *
 *     E-mail: support@superwaba.com.br                                          *
 *                                                                               *
 *********************************************************************************/

package waba.ui;

import waba.applet.Applet;
import waba.sys.Settings;

/** This class is for internal use only. There are no public methods. */

final public class NativeMethods4JDK
{
   ////////////////////////////////////////////////////////////////////////////////////
   //                                 waba.ui.Window                                 //
   ////////////////////////////////////////////////////////////////////////////////////
   static void windowCreate(Window obj)
   {
	   obj.x = 0;
	   obj.y = 0;
	   obj.width = Settings.screenWidth;
	   obj.height = Settings.screenHeight;
   }
   static void windowSetStatePosition(Window obj, int x, int y)
   {
   }
   static void windowPumpEvents()
   {
      waba.applet.WinCanvas.pumpEvents();
   }
   ////////////////////////////////////////////////////////////////////////////////////
   //                               waba.ui.MainWindow                               //
   ////////////////////////////////////////////////////////////////////////////////////
   static void mainWindowCreate(MainWindow obj)
   {
      Applet.currentApplet.registerMainWindow(obj);
   }
   static final void mainWindowExit(int exitCode)
   {
	   Applet.currentApplet.exit(exitCode);
   }
   static void mainWindowSetTimerInterval(int milliseconds)
   {
      Applet.currentApplet._setTimerInterval(milliseconds);
   }
   static String mainWindowGetCommandLine()
   {
      return Applet.currentApplet.commandLine;
   }
   static void mainWindowSetThreadCount(int count)
   {
      waba.applet.WinTimer.threadCount = count;
   }
   ////////////////////////////////////////////////////////////////////////////////////
   //                                 waba.ui.Event                                  //
   ////////////////////////////////////////////////////////////////////////////////////
   static boolean eventIsAvailable()
   {
      return waba.applet.WinCanvas.eventIsAvailable();
   }
}